//  The Worldforge Project
//  Copyright (C) 1998, 1999 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 02/2000

#define NEED_DII_SERVICES

#include "dialogs.h"

#include "editscreen.h"
#include "dii/dii.h"
#include "logindialog.h"
#include "operation.h"
#include "overview.h"
#include "inventorydialog.h"
#include "charchooser.h"

#include "../modules/gui.h"
#include "../player/player.h"
#include "../modules/console.h"

#include "toolbox/operation.h"

#include <varconf/Config.h>

#include <uta/debug.h>
#include <uta/resources.h>

using namespace uta;

using namespace DII;

class Dialogs* Dialogs::instance_ = 0;

void
Dialogs::deinit()
{
  Gui *gui = Gui::instance();
  assert(gui);

//   string mode = varconf::Config::inst()->getItem("","mode");
//   if(mode != string("standalone"))
//     gui->release_menubutton(but_login);

//   gui->release_menubutton(but_ec);
  try {
  gui->release_menubutton((int)but_map.AsMap()["id"].AsNum());
   } catch(...) {}
  try {
  gui->release_menubutton((int)but_inv.AsMap()["id"].AsNum());
   } catch(...) {}
  
//  gui->release_menubutton((int)but_quit.AsMap()["id"].AsNum());
  try {
  gui->release_menubutton((int)but_help.AsMap()["id"].AsNum());
   } catch(...) {}
}

bool
Dialogs::init(DII::Module*)
{ 
  Gui *gui = Gui::instance();
  assert(gui);

  //  bool standalone = varconf::Config::inst()->getItem("flags","standalone");

//   if(!standalone)
//     {
//       but_login = gui->bind_menubutton();
//       if(but_login == DII::FAILURE)
// 	return DII::FAILURE;
//       but_login.AsMap()["text"] = string("L");
//       gui->change_menubutton(but_login);
//     }
//   else
//     {
//       but_login = DII::Object::MapType();
//       but_login.AsMap()["id"] = 0;
//     }

//   but_ec = gui->bind_menubutton();
//   if(but_ec == DII::FAILURE)
//     return DII::FAILURE;
//   but_ec.AsMap()["text"] =  string("C");
//   gui->change_menubutton(but_ec);

  unsigned int but_map_id = gui->bind_menubutton();
  if(but_map_id == 0)
    return false;
  but_map = DII::Object::MapType();
  but_map.AsMap()["id"] = (int) but_map_id;
  but_map.AsMap()["upPic"] = std::string("mmap_button");
  but_map.AsMap()["downPic"] =  std::string("mmap_button_pressed");
  gui->change_menubutton(but_map);

  unsigned int but_inv_id = gui->bind_menubutton();
  if(but_inv_id == 0)
    return false;
  but_inv = DII::Object::MapType();
  but_inv.AsMap()["id"] = (int) but_inv_id;
  but_inv.AsMap()["upPic"] =  std::string("maction_button");
  but_inv.AsMap()["downPic"] = std::string("maction_button_pressed");
  gui->change_menubutton(but_inv);
  
  unsigned int but_help_id = gui->bind_menubutton();
  if(but_help_id == 0)
    return false;
  but_help = DII::Object::MapType();
  but_help.AsMap()["id"] = (int) but_help_id;
  but_help.AsMap()["upPic"] =  std::string("mhelp_button");
  but_help.AsMap()["downPic"] = std::string("mhelp_button_pressed");
  gui->change_menubutton(but_help);

//   but_quit = gui->bind_menubutton();
//   if(but_quit == DII::FAILURE)
//     return DII::FAILURE;
//   but_quit.AsMap()["upPic"] =  ptrToObj<const uta::Surface*>(SURFACE_RES("mibutton"));
//   but_quit.AsMap()["downPic"] = ptrToObj<const uta::Surface*>(SURFACE_RES("mibutton_pressed"));
//   but_quit.AsMap()["text"] = string("X");
//   gui->change_menubutton(but_quit);

     if(gui) {
        //gui->installHandler("userinput", lookupMethod("handler"));
        gui->buttonClicked.connect(SigC::slot(this, &Dialogs::handler));
     }

  return true;
}

bool
Dialogs::handler(const Atlas::Objects::Operation::RootOperation& op)
{
  const DII::Object::ListType& args = op.GetArgs();

  if(args.size() > 0)
    {  
      DII::Object::MapType arg0 = args.begin()->AsMap();

      if(arg0["what"].AsString()=="clicked")
	{  
	  if(arg0["button"].AsString()=="menu")
	    {  
// 	      if(arg0["id"].AsInt() == but_login.AsMap()["id"].AsInt())
// 		login(0);
// 	      else if(arg0["id"].AsInt() == but_ec.AsMap()["id"].AsInt())
// 		chooseCharacter(0);
	      if(arg0["id"].AsInt() == but_map.AsMap()["id"].AsInt())
		{
		  static bool lock = false;
		  if(!lock)
		    {
		      lock = true;
		      showMap();	  
		      lock = false;
		    }
		}
	      else if(arg0["id"].AsInt() == but_inv.AsMap()["id"].AsInt())
		{
		  if(Player::instance())
		    Player::instance()->say(std::string("Sowee !"));
		}
// 	      else if(arg0["id"].AsInt() == but_quit.AsMap()["id"].AsInt())
//		{
//		  if(App::instance())
//		    App::instance()->quit(0);
//		}
	      else if(arg0["id"].AsInt() == but_help.AsMap()["id"].AsInt())
		{
		  DII::Object info = DII::callService("help");
		  if(info.IsString() && Console::instance())
		    Console::instance()->std_out(info.AsString());
		}
			
	    }

	}
    }
  return false;
}


bool
Dialogs::editCharacter()
{
  EditScreen dialog;
      
  return (dialog.exec() == Screen::OK);
}

bool
Dialogs::chooseCharacter()
{
  
  CharChooser dialog;
  
  return (dialog.exec() == Screen::OK);
}


bool
Dialogs::login()
{
  LoginDialog dialog;
  
  return (dialog.exec() == Screen::OK);
}

void
Dialogs::showMap()
{
  
  Overview overview;
  overview.exec();
}

void
Dialogs::inventory()
{
  
  InventoryDialog inventory;
  inventory.exec();
}
