//  The Worldforge Project
//  Copyright (C) 1998, 1999 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 02/2000


#ifndef _DIALOGS_H_
#define _DIALOGS_H_

#include <sigc++/object.h>
#include <Atlas/Objects/Operation/RootOperation.h>

#include "dii/object.h"
namespace DII {class Module;}

///
class Dialogs : virtual public SigC::Object
{
  
 public:
  
  ///
  Dialogs() {assert(!instance_); instance_ = this;}
  ///
  virtual ~Dialogs() {assert(instance_); instance_ = 0;}
  
  ///
  bool editCharacter();
  ///
  bool login();
  ///
  void showMap();
  ///
  void inventory();
  ///
  bool chooseCharacter();

  ///
  bool init(DII::Module*);
  ///
  void deinit();
  ///
  static Dialogs* instance() {return instance_ ? instance_ : new Dialogs();}

  ///
  bool handler(const Atlas::Objects::Operation::RootOperation&);
 
 protected:

  ///
  DII::Object but_login;
  ///
  DII::Object but_ec;
  ///
  DII::Object but_map;
  ///
  DII::Object but_inv;
  ///
  DII::Object but_quit;
  ///
  DII::Object but_help;

  static Dialogs* instance_;
};

#endif
