//  Copyright (C) 1998, 1999 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 02/2000

#ifndef _EDITSCREEN_H_
#define _EDITSCREEN_H_

#include <uta/pushbutton.h>
#include <uta/lineedit.h>
#include <uta/multilineedit.h>

#include "dialog.h"
#include "widgets.h"

///
class EditScreen : public Screen
{
  public:
  
  ///
  EditScreen();
  ///
  virtual ~EditScreen();

 protected:
  ///
  virtual uta::Widget* create(uta::Widget*, int,int,int,int);
  ///
  virtual void cleanup();

  ///generate new character
  void generate();
  ///updata server's character information ...
  void updChar();
  ///
  void changePortrait();
  ///
  void changeGender();

  ///widgets->registry
  void wbdata();
  ///registry->widgets
  void rddata();
  
  ///
  FixLineEdit* characterName_;
  ///
  //  uta::LineEdit* sex_;
  ///
  FixComboEdit* type_;
  ///
  uta::MultiLineEdit* description_;
  ///
  uta::Widget* image_;
  ///
  unsigned index_;
  ///
  std::vector<std::string> portraits_;
  ///
	uta::PushButton* genbut;
  ///
	uta::PushButton* updbut;
  ///
	uta::PushButton* change;
  ///
	uta::PushButton* genderbut;
  ///
  uta::Widget* charImg;
  ///
  //TODO: What about neutral?
  bool female;
};




#endif // !_EDITSCREEN_H_
