//  The Worldforge Project
//  Copyright (C) 1998, 1999, 2000 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 07/2000

#ifndef _DII_MESSAGE_H_
#define _DII_MESSAGE_H_

#include "object.h"
#include <string>

namespace DII {

///
class Message 
{
 public:
  ///
  Message(const std::string& s, const std::string& r, const Object& d = 0) :
    sender(s), receiver(r), data(d) 
    {
    };
  ///
  virtual ~Message() {};
  ///
  std::string sender;
  ///
  std::string receiver;
  ///
  const Object data;
};

///
class Broadcast : public Message
{
 public:
  ///
  Broadcast(const std::string& s, const Object& d = 0) :
    Message(s,"",d) {};
  ///
  virtual ~Broadcast() {};
};

} // namespace 

#endif // !_DII_MESSAGE_H_

