//  The Worldforge Project
//  Copyright (C) 2002 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Ron Steinke 05/2002

// This is a generated file, do not edit. Generated from method_convert.h.m4.



#ifndef _DII_METHOD_CONVERT_H_
#define _DII_METHOD_CONVERT_H_

#include "dii/method.h"
#include <sigc++/convert.h>
#include "dii/class_mod.h"

namespace SigC
{

/****************************************************************
***** Adaptor Convert Slot 1
****************************************************************/
template <class R1,class P1,
          class R2>
struct AdaptorConvertSlot1_0: public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot1<R1,P1> SlotType;
   typedef Slot0<R2> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef R1    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
      return (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };



#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,
          class R2>
struct AdaptorConvertSlot1_0
         <void,P1,
          R2>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot1<void,P1> SlotType;
   typedef Slot0<R2> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef void    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
       (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };


#endif
#endif

template <class R1,class P1,
          class R2>
Slot1<R1,P1>
  convert(const Slot0<R2> &s,
          R1 (*func)(Callback0<R2>*,P1))
  {return AdaptorConvertSlot1_0<R1,P1,
           R2>::create(s.obj(),func);
  }


/****************************************************************
***** Adaptor Convert Slot 1
****************************************************************/
template <class R1,class P1,
          class R2,class Q1,class Q2>
struct AdaptorConvertSlot1_2: public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot1<R1,P1> SlotType;
   typedef Slot2<R2,Q1,Q2> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef R1    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
      return (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };



#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,
          class R2,class Q1,class Q2>
struct AdaptorConvertSlot1_2
         <void,P1,
          R2,Q1,Q2>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot1<void,P1> SlotType;
   typedef Slot2<R2,Q1,Q2> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef void    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
       (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };


#endif
#endif

template <class R1,class P1,
          class R2,class Q1,class Q2>
Slot1<R1,P1>
  convert(const Slot2<R2,Q1,Q2> &s,
          R1 (*func)(Callback2<R2,Q1,Q2>*,P1))
  {return AdaptorConvertSlot1_2<R1,P1,
           R2,Q1,Q2>::create(s.obj(),func);
  }


/****************************************************************
***** Adaptor Convert Slot 1
****************************************************************/
template <class R1,class P1,
          class R2,class Q1,class Q2,class Q3>
struct AdaptorConvertSlot1_3: public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot1<R1,P1> SlotType;
   typedef Slot3<R2,Q1,Q2,Q3> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef R1    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
      return (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };



#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,
          class R2,class Q1,class Q2,class Q3>
struct AdaptorConvertSlot1_3
         <void,P1,
          R2,Q1,Q2,Q3>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot1<void,P1> SlotType;
   typedef Slot3<R2,Q1,Q2,Q3> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef void    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
       (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };


#endif
#endif

template <class R1,class P1,
          class R2,class Q1,class Q2,class Q3>
Slot1<R1,P1>
  convert(const Slot3<R2,Q1,Q2,Q3> &s,
          R1 (*func)(Callback3<R2,Q1,Q2,Q3>*,P1))
  {return AdaptorConvertSlot1_3<R1,P1,
           R2,Q1,Q2,Q3>::create(s.obj(),func);
  }


/****************************************************************
***** Adaptor Convert Slot 1
****************************************************************/
template <class R1,class P1,
          class R2,class Q1,class Q2,class Q3,class Q4>
struct AdaptorConvertSlot1_4: public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot1<R1,P1> SlotType;
   typedef Slot4<R2,Q1,Q2,Q3,Q4> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef R1    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
      return (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };



#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,
          class R2,class Q1,class Q2,class Q3,class Q4>
struct AdaptorConvertSlot1_4
         <void,P1,
          R2,Q1,Q2,Q3,Q4>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot1<void,P1> SlotType;
   typedef Slot4<R2,Q1,Q2,Q3,Q4> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1);
   typedef void    (*InFunc)(Callback*,P1);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1)
     {
      CallData* data=(CallData*)d;
       (data->func)(data->obj,p1);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };


#endif
#endif

template <class R1,class P1,
          class R2,class Q1,class Q2,class Q3,class Q4>
Slot1<R1,P1>
  convert(const Slot4<R2,Q1,Q2,Q3,Q4> &s,
          R1 (*func)(Callback4<R2,Q1,Q2,Q3,Q4>*,P1))
  {return AdaptorConvertSlot1_4<R1,P1,
           R2,Q1,Q2,Q3,Q4>::create(s.obj(),func);
  }



/****************************************************************
***** Adaptor Convert Slot 2
****************************************************************/
template <class R1,class P1,class P2,
          class R2,class Q1>
struct AdaptorConvertSlot2_1: public AdaptorSlot_
  {
#ifdef SIGC_CXX_PARTIAL_SPEC
   typedef R1 RType;
#else
   typedef typename Trait<R1>::type RType;
#endif
   typedef Slot2<R1,P1,P2> SlotType;
   typedef Slot1<R2,Q1> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1,P2);
   typedef R1    (*InFunc)(Callback*,P1,P2);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1,P2 p2)
     {
      CallData* data=(CallData*)d;
      return (data->func)(data->obj,p1,p2);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };



#ifndef SIGC_CXX_VOID_RETURN
#ifdef SIGC_CXX_PARTIAL_SPEC
template <class P1,class P2,
          class R2,class Q1>
struct AdaptorConvertSlot2_1
         <void,P1,P2,
          R2,Q1>
  : public AdaptorSlot_
  {
   typedef void RType;
   typedef Slot2<void,P1,P2> SlotType;
   typedef Slot1<R2,Q1> InSlotType;
   typedef typename InSlotType::Callback Callback;
   typedef RType (*Func)  (Callback*,P1,P2);
   typedef void    (*InFunc)(Callback*,P1,P2);
   typedef CallDataObj3<typename SlotType::Func,Callback,Func> CallData;

   static RType callback(void* d,P1 p1,P2 p2)
     {
      CallData* data=(CallData*)d;
       (data->func)(data->obj,p1,p2);
     }

   static SlotData* create(SlotData *s,InFunc func)
     {
      SlotData* tmp=(SlotData*)s;
      AdaptorNode *node=new AdaptorNode();
      copy_callback(tmp,node);
      CallData &data=reinterpret_cast<CallData&>(tmp->data_);
      data.callback=&callback;
      data.func=(Func)func;
      data.obj=(Callback*)&(node->data_);
      return tmp;
     }
  };


#endif
#endif

template <class R1,class P1,class P2,
          class R2,class Q1>
Slot2<R1,P1,P2>
  convert(const Slot1<R2,Q1> &s,
          R1 (*func)(Callback1<R2,Q1>*,P1,P2))
  {return AdaptorConvertSlot2_1<R1,P1,P2,
           R2,Q1>::create(s.obj(),func);
  }



} // namespace SigC

#define WRAP_CONVERT_METHOD(modname, meth_name, conv_func) \
  std::pair<const char*, DII::Method>(#meth_name, \
    new DII::SlotHandle<DII::Object,const DII::Object&>( \
      SigC::convert(SigC::slot(modname::instance(), &modname::meth_name), \
        conv_func)))

#endif // !_DII_METHOD_CONVERT_H_
