//  The Worldforge Project
//  Copyright (C) 1998, 1999, 2000 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 07/2000

#ifndef _DII_OBJECT_H_
#define _DII_OBJECT_H_

#include <Atlas/Message/Object.h>
#include "toolbox/operation.h"

/* #define OLD_ATLAS */
/* #include <Atlas/Object/Object.h> */

//#include "Morph.h"

namespace DII {

///  
  //typedef Atlas::Object Object;

  typedef Atlas::Message::Object Object;
  //typedef Morph Object;

  template<class C> struct ObjConv
  {
    static C convert(const Object&);
  };

  template<class C> struct ObjConv<const C&>
  {
    static C convert(const Object &obj) {return ObjConv<C>::convert(obj);}
  };

  template<class C> struct ObjConv<C*>
  {
    static C* convert(const Object &obj) {return objToPtr<C*>(obj);}
  };

  // Avoid an extra copy
  template<> struct ObjConv<const Object&>
  {
    static const Object& convert(const Object &obj) {return obj;}
  };

  template<> inline
    Object ObjConv<Object>::convert(const Object &obj) {return obj;}
  template<> inline
    int ObjConv<int>::convert(const Object &obj) {return obj.AsInt();}
  template<> inline
    long ObjConv<long>::convert(const Object &obj) {return obj.AsInt();}
  template<> inline
    float ObjConv<float>::convert(const Object &obj) {return obj.AsFloat();}
  template<> inline
    double ObjConv<double>::convert(const Object &obj) {return obj.AsFloat();}
  template<> inline
    std::string ObjConv<std::string>::convert(const Object &obj) {return obj.AsString();}

}

#endif
