#include <stdio.h>
#ifndef _MSC_VER
#include <unistd.h>
#include <sys/time.h>
#else
#include <sys/timeb.h>
#endif

#define NEED_DII_SERVICES


#include "dii/dii.h"
#include "loader.h"
#include "serialize.h"

using namespace DII;

//timeval begin_time;
//timeval end_time;

long loops = 100000;

int plain_int(int n)
{
  return n;
}


DII::Object obj3_int(const DII::Object& obj)
{
  return obj;
}

DII::Object obj_int(const DII::Object& obj)
{
#ifdef OLD_ATLAS
  return DII::Object(obj.asInt());
#else
  return DII::Object(obj.AsInt());
#endif
}

string plain_string(const string& s)
{
  return s;
}


int main (int argc, char** argv)
{

  cerr << "Testing uclient's Dynamic Module System :" << endl;

  string hello = "Hello World !";

  Object obj(hello);

  Object obj2(100); 
  Object str("This is a string object");

  Object::ListType mylist;
  mylist.push_back(string("number 1"));
  mylist.push_back(string("number 2"));
  mylist.push_back(string("number 3"));

  Object::MapType mymap;
  mymap["hello"]=string("world");
  mymap["text"] = str;
  mymap["pointer"]=0;
  mymap["liste"] = mylist;

  Serialize::write(mymap,"test.xml");

  Object readTest;
  Serialize::read("test.xml",readTest);

  Loader::setSearchPath("./.libs");
  Loader::loadModule("Testmod");
  
  if(lookupModule("Testmod"))
    cerr << "successfully loaded Testmod " << endl;
  if(lookupModule("Bogo"))
    cerr << "successfully loaded Bogo " << endl;

  Loader::dump(cerr);

  Object result;

//   Message msg("test",string("2"));
//   Broadcaster::send(msg);

  Method method;
  Module *mod = lookupModule("Bogo");

  if(mod)
    {
      result = mod->init(0);
      method = mod->lookupMethod("process_int");
    }

  slist<string> services;
  slist<string>::iterator itr;
  
  cerr << "--------------services :--------------" << endl;
  services = DII::queryServices();
  itr = services.begin();
  while(itr != services.end())
      cerr << *itr++ << endl;
  cerr << "--------------------------------------" << endl;

  Loader::setScriptPath("..");
  Loader::loadScript("hello");

  if(lookupModule("hello"))
    cerr << "successfully loaded hello " << endl;

  //  Loader::dump(cerr);

  DII::callMethod("hello","hellolua");
  DII::callService("hellolua");


//   cerr << endl
//        << "now for the performance : (" << loops << " loops)" << endl << endl;

//   int n;
//   int test_int;
//   string test_string;

//   cerr << "int function(int): " << endl;
  
  
//   BEGIN_TEST("\tplain function call: ");
//   test_int = plain_int(test_int);
//   END_TEST

//     cerr << endl << "DII::Object function (const DII::Object&):"<<endl;

//   BEGIN_TEST("\tplain function call with DII::Objects: ");
//   test_int = obj_int(test_int).AsInt();
//   END_TEST

//   BEGIN_TEST("\tplain function call with old DII::Objects: ");
//   test_int = obj3_int(test_int).asInt();
//   END_TEST

//   BEGIN_TEST("\tusing mod->callMethod(\"process_int\"): ");
//   test_int = mod->callMethod("process_int",test_int).AsInt();
//   END_TEST

//   BEGIN_TEST("\tusing DII::callService(\"process_int\"): ");
//   test_int = DII::callService("process_int",test_int).AsInt();
//   END_TEST

//   BEGIN_TEST("\tusing DII::callMethod(\"Bogo\",\"process_int\"): ");
//   test_int = DII::callMethod("Bogo","process_int",test_int).AsInt();
//   END_TEST

//   BEGIN_TEST("\tusing function pointer: ");
//   test_int = (*method)(test_int).AsInt();
//   END_TEST

//   cerr << "int function(int): " << endl;
  
//   BEGIN_TEST("\tplain function call: ");
//   test_int = plain_int(test_int);
//   END_TEST
  

  return 0;
}
  
  
  
