//
//  The Worldforge Project
//  Copyright (C) 1998, 1999 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//

//  written by Karsten <klaux@rhrk.uni-kl.de> in August 2000

#ifndef _MEDIA_INDEX_H_
#define _MEDIA_INDEX_H_

#include <string>
#include <iostream>
#include "toolbox/local_hash_map.h"

/**media repository index.
   based on the file media.ind this class provides searches for a file
   inside the media repository and returns the complete absolute path. 
   MediaIndex stores the base-filename without file extension as key, 
   so if you want to lookup the file "example_1.png" you have to call 

   MediaIndex::lookupFilename("example_1") !

 */
class MediaIndex
{
 public:
  ///
  MediaIndex() {};
  ///
  ~MediaIndex() {};
  ///
  static bool initialize(const std::string& install_dir);
  ///
  static const std::string& lookupFilename(const std::string& name);

 private:    
  ///
  typedef STRING_HASH_MAP(std::string) Index;
  ///
  static Index index_;
  ///
  static std::string emptyString_;
};

#endif

