//
//  The Worldforge Project
//  Copyright (C) 1998,1999  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 10/2000

#include <uta/resources.h>

#include "action_chooser.h"
#include "ftos.h"

using namespace uta;

ActionChooser::ActionChooser(const std::vector<std::string>& actions, unsigned min, unsigned max) : 
  uta::uDialogBox("What now ?")
{
 // no longer used?
//  int w = width() - 32;
//  int h = height() - 32;

  action_ = new ListBox(this, 32, 32, width()-64, 60);
  action_->addElements(actions);
  action_->setSelectedColor(Color(64,64,64,128));
  action_->setBackground(SURFACE_RES("background"));

  Label* label = new Label(this, 32, 32+65, 70, 20);
  label->setText("Amount:");
  label->setAlign(Label::ALIGN_LEFT);

  value_ = new Label(this, 32+75, 32+65, 40, 25);

  amount_ = new Slider(this, 32, 32+90, width()-64, 25);
  amount_->setRange(min, max);
  amount_->valueChanged.connect(slot(this, &ActionChooser::slot_slider));
  amount_->setValue(1);


  PushButton* ok = new PushButton(this,16 ,height()-16-25, 70, 25);
  ok->setText("OK");
  ok->clicked.connect(slot(this, &Dialog::accept));

  PushButton* cancel = new PushButton(this,width()-16-70 ,height()-16-25, 70, 25);
  cancel->setText("Cancel");
  cancel->clicked.connect(slot(this, &Dialog::reject));
}

  
void 
ActionChooser::slot_slider(int n)
{
  value_->setText(itos(n).c_str());
}
