//
//  The Worldforge Project
//  Copyright (C) 1998,1999  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 01/1999

#ifndef _APP_MOD_H
#define _APP_MOD_H

#include <string>
#include <sigc++/object.h>
#include <uta/timer.h>

namespace DII {class Module;}

///
class App : virtual public SigC::Object
{

public:

  ///
  App() : tick_(1000) {assert(!instance_); instance_ = this;}
  ///
  virtual ~App() {assert(instance_); instance_ = 0;}
  
  ///
  void slot_message(const std::string&);
  ///
  void quit();
  ///
  std::string version();
  ///
  bool init(DII::Module* module);
  ///
  static App* instance() {return instance_ ? instance_ : new App();}

 protected:
  ///
  uta::Timer tick_;

  static App* instance_;
};

#endif // _APP_MOD_H
