//
//  The Worldforge Project
//  Copyright (C) 1998,1999  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 07/2000

#ifndef _INVENTORY_H_
#define _INVENTORY_H_

#include <sigc++/object.h>

#include "inventory_panel.h"

namespace DII {class Module;}

///
class Inventory : virtual public SigC::Object
{
 public:
  
  ///
  Inventory() : panel_(0) {assert(!instance_); instance_ = this;}
  ///
  virtual ~Inventory() {assert(instance_); instance_ = 0;}
  ///
  static Inventory* instance() {return instance_ ? instance_ : new Inventory();}
  ///
  bool init(DII::Module*);
  ///
  void deinit();

  ///accepts list of ids
  bool update(const std::list<std::string>&);
  
 protected:

  ///
  InventoryPanel* panel_;


  static Inventory* instance_;
};

#endif
