//
//  The Worldforge Project
//  Copyright (C) 1998,1999  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 07/2000

#ifndef _INVENTORY_PANEL_H
#define _INVENTORY_PANEL_H

#include <uta/widget.h>
#include <uta/font.h>
#include <uta/label.h>
#include <uta/pushbutton.h>
#include <uta/timer.h>
#include <map>


///
class InventoryPanel : public uta::Widget
{
 public:
  ///
  InventoryPanel(uta::Widget* parent, int x, int y, int w, int h);
  ///
  virtual ~InventoryPanel();
  ///
  void update(const std::list<std::string>&);
  ///
  void updateWidget();

 protected:
  ///
  virtual void slot_scrollUp();
  ///
  virtual void slot_scrollDown();
  ///
  typedef std::list<std::string> IDList;
  ///
  typedef struct {
    IDList ids;
    uta::Surface* icon_few;
    uta::Surface* icon_some;
    uta::Surface* icon_many;
  } ItemEntry;

  ///
  typedef std::map<std::string, ItemEntry> Content;
  ///
  Content content_;
  ///
  typedef struct {
    uta::Button* button;
    uta::Label* label;
  } ItemSlot;

  ///
  std::vector<ItemSlot> slots_;
  ///
  unsigned offset_;
  ///
  uta::PushButton* up;
  ///
  uta::PushButton* down;
  ///
  void addItemEntry(const std::string&, const uta::Surface&);
  ///
  void selectItem(int);
  ///
  bool center(const uta::Surface*, uta::Surface* dst);
};


#endif
