//
//  The Worldforge Project
//  Copyright (C) 1998,1999  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 02/2001

#ifndef _OBSERVER_H_
#define _OBSERVER_H_

#include <sigc++/object.h>

#include "world/world_adaptor.h"

namespace DII {class Module;}

#include <list>

///
class Observer : virtual public SigC::Object, public World::Adaptor
{
 public:
  
  ///
  Observer() : Adaptor(::World::World::inst()) {assert(!instance_); instance_ = this;}
  ///
  virtual ~Observer() {assert(instance_); instance_ = 0;}
  ///
  bool init(DII::Module*);
  ///
  static Observer* instance() {return instance_ ? instance_ : new Observer();}

  ///
  void addID(const std::string&);
  ///
  void removeID(const std::string&);
   
  ///
  void disappeared(const World::Entity*);
  ///
  void moved(const World::Entity*);
  ///  
  void changed(const World::Entity*);
  ///
  void deleted(const World::Entity*);
  ///  
  void created(const World::Entity*);
 
  SigC::Signal1<bool, const Atlas::Message::Object&,
	SigC::FixedMarshal<bool,false> > signal;

 protected:
  ///
  std::list<std::string> toObserv_;

  static Observer* instance_;
};

#endif
