//
//  The Worldforge Project
//  Copyright (C) 1998,1999  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 01/1999

#ifndef _PANEL_H
#define _PANEL_H

#include <uta/widget.h>
#include <uta/lineedit.h>
#include <uta/terminal.h>
#include <uta/slider.h>

///
class Panel : public uta::Widget
{
 public:
  ///
  Panel(uta::Widget* parent , 
	int x, int y, int w, int h);
  ///
  virtual ~Panel();

  ///
  void addMessage(const char*);
  ///
  void command (const char*);
  ///
  void history_up ();
  ///
  void history_down ();

  ///hotkey filter
  bool keyfilter(const uta::KeyEvent*);
  ///
  SigC::Signal1<std::string, const std::string&> userinput;
  ///
  std::string getText() { return chatWin_->getText(); };
 
 protected:

  ///
  void slot_scrollbar(int);
  ///
  void slot_terminal();
  ///
  uta::Slider *scrollbar_;
  ///
  uta::Terminal *chatWin_;
  ///
  uta::LineEdit *console_;
  ///
  void history_completize();
  ///
  void history_prev();
  ///
  void history_next();
  ///
  void history_add(const std::string&);
  ///
  std::vector<std::string> history_;
  ///
  size_t index_;
};

#endif
