#include "tokenise.h"

using std::string;

string running_tokenise(const string &s,std::queue<string> &argc)
{

	// purpose is to break a string up into components
	string::const_iterator iter;
	string this_string = "";
	for(iter = s.begin(); iter != s.end(); iter++)
	{
		if((*iter) == '#')
			while((*(++iter)) != '\n');	// comment goes to end 
							// of line
		if((*iter) == '\n' || (*iter) == 13 || (*iter) == ' ' || (*iter) == '\t')
		{
			if(this_string != "")
				argc.push(this_string);
			this_string = "";
		}
		else if((*iter) == '\"')
		{
			if(this_string != "")
				argc.push(this_string);
			this_string = "\"";
			while((*(++iter)) != '\"')
				this_string += (*iter);
			this_string += "\"";
			if(this_string != "")
				argc.push(this_string);
			this_string = "";
		}
		else this_string += (*iter);
	}
	return this_string;	
}

void tokenise(std::istream &in,std::queue<string> &argc)
{
	string this_string;
	while(in.peek() != EOF)
		this_string += in.get();
	tokenise(this_string,argc);
}


string flatten(std::queue<string> &tkns)
{
	string out = "";
 	while(!tkns.empty())
	{
		out +=  tkns.front();
		tkns.pop();
		if(!tkns.empty())
		  out+= " ";
	}
 	return out;
}
