#include <string>
#include <queue>
#if __GNUC__ < 3
#include <istream.h>
#elif defined(__APPLE__) // darwin/OSX
#include <iostream>
#else
#include <istream>
#endif

#ifndef TOKEN_H
#define TOKEN_H

std::string running_tokenise(const std::string &s, std::queue<std::string> &tokens);
void tokenise(const std::string &s,std::queue<std::string> &tokens);
void tokenise(std::istream &in,std::queue<std::string> &argc);

inline void tokenise(const std::string &s,std::queue<std::string> &tokens)
{
	std::string temp = running_tokenise(s,tokens);
	if(temp != "")
		tokens.push(temp);
}

std::string flatten(std::queue<std::string> &tkns);
	
#endif	
