//  The Worldforge Project
//  Copyright (C) 1998, 1999 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 06/2000


#ifndef _MUSIC_MODULE_H_
#define _MUSIC_MODULE_H_

#include <sigc++/object.h>
#include <uta/timer.h>
#include <uta/music.h>

#include "dii/object.h"
namespace DII {class Module;}

///
class MusicModule : virtual public SigC::Object
{
 public:
  
  ///
  MusicModule();
  ///
  virtual ~MusicModule() {assert(instance_); instance_ = 0;}

  ///
  bool init(DII::Module*);
  ///
  void deinit();
  ///
  static MusicModule* instance() {return instance_ ? instance_ : new MusicModule();}

  ///
  void play();
  ///
  void stop();
  ///
  void pause();
  ///
  void resume();

  ///
  void music_vol(int);

  ///
  bool eventHandler(const DII::Object&);

  ///
  void tick();  
 
 protected:
  ///
  uta::Timer timer_;
  ///
  std::vector< std::string > songs_;
  ///
  uta::Music* currentSong_;
  ///
  int volume_;

  static MusicModule *instance_;
};

#endif
