#include "msgdispatch.h"
// Comment out the following two includes, and all the debugMap stuff
// in a production environment
#ifdef DEBUG
#include <iostream>
#include <map>
#endif

using namespace Atlas::Message;
using namespace std;

/*  this is some code from Atlas-C++/src/Objects/Decoder.cc,
    I have added a "return;" to the macro, because once we have found the correct
    type we do not need to check for others.

    FIXME ... this does not stream !
 */

#ifdef DEBUG
std::map<std::string, int> debugMap;
#define DEBUG_MAP_INC(a) debugMap[a]++
#else
#define DEBUG_MAP_INC(a)
#endif

#define ENTITYCHECK(a, b) if (parent == a) { \
    Atlas::Objects::Entity::b obj; \
    for (Atlas::Message::Object::MapType::const_iterator I = o.AsMap().begin(); \
            I != o.AsMap().end(); I++) \
        obj.SetAttr(I->first, I->second); \
      DEBUG_MAP_INC(a); \
      Entity##b##Arrived(obj);\
    return;\
}

#define OPCHECK(a, b) if (parent == a) { \
    Atlas::Objects::Operation::b obj; \
    for (Atlas::Message::Object::MapType::const_iterator I = o.AsMap().begin(); \
            I != o.AsMap().end(); I++) \
        obj.SetAttr(I->first, I->second); \
    DEBUG_MAP_INC(a); \
    Op##b##Arrived(obj);\
    return;\
}


MsgDispatch::MsgDispatch()
{
}

MsgDispatch::~MsgDispatch()
{
#ifdef DEBUG
  for (std::map<std::string, int>::const_iterator I = debugMap.begin();
      I != debugMap.end();
      ++I) {
    std::cerr << I->first << ": [" << I->second << "]\n";
  }
#endif
}

void MsgDispatch::ObjectArrived(const Atlas::Message::Object& o)
{
    if (!o.IsMap()) return;
    //    cerr << "MsgDispatch: received object ... " << endl;

    if (o.AsMap().find("parents") == o.AsMap().end())
        { UnknownObjectArrived(o); return; }
    if ((*o.AsMap().find("parents")).second.AsList().size() != 1)
        { UnknownObjectArrived(o); return; }
    
    string parent =
      ((*(*o.AsMap().find("parents")).second.AsList().begin()).AsString());
    
    if (parent == "root") 
      {
        Atlas::Objects::Root obj;
        Atlas::Message::Object::MapType::const_iterator I; 
        for (I = o.AsMap().begin(); I != o.AsMap().end(); I++) 
          obj.SetAttr(I->first, I->second); 
        RootObjectArrived(obj);
        return;
      }
 
    // Since success will short-circuit the following code, the
    // checks are ordered such that the most common operaions
    // come first.  The order is based on sampling code (the
    // DebugMap, above)
    OPCHECK("sight", Sight)
    OPCHECK("talk", Talk)
    OPCHECK("appearance", Appearance)
    OPCHECK("disappearance", Disappearance)
    OPCHECK("touch", Touch)
    OPCHECK("info", Info)
    OPCHECK("sound", Sound)
    OPCHECK("move", Move)
    OPCHECK("action", Action)

    ENTITYCHECK("game_entity", GameEntity)
		
    OPCHECK("combine", Combine)
    OPCHECK("create", Create)
    OPCHECK("delete", Delete)
    OPCHECK("divide", Divide)
    OPCHECK("error", Error)
    OPCHECK("feel", Feel)
    OPCHECK("get", Get)
    OPCHECK("imaginary", Imaginary)
    OPCHECK("listen", Listen)
    OPCHECK("login", Login)
    OPCHECK("logout", Logout)
    OPCHECK("look", Look)
    OPCHECK("perceive", Perceive)
    OPCHECK("perception", Perception)
    OPCHECK("root_operation", RootOperation)
    OPCHECK("set", Set)
    OPCHECK("smell", Smell)
    OPCHECK("sniff", Sniff)

    ENTITYCHECK("account", Account)
    ENTITYCHECK("admin", Admin)
    ENTITYCHECK("admin_entity", AdminEntity)
    ENTITYCHECK("game", Game)
    ENTITYCHECK("player", Player)
    ENTITYCHECK("root_entity", RootEntity)

#ifdef DEBUG
    debugMap["unknown"]++;
#endif
    UnknownObjectArrived(o);
}
