#include <Atlas/Message/DecoderBase.h>
#include <Atlas/Objects/Root.h>
#include <Atlas/Objects/Entity/Account.h>
#include <Atlas/Objects/Entity/Admin.h>
#include <Atlas/Objects/Entity/AdminEntity.h>
#include <Atlas/Objects/Entity/Game.h>
#include <Atlas/Objects/Entity/GameEntity.h>
#include <Atlas/Objects/Entity/Player.h>
#include <Atlas/Objects/Entity/RootEntity.h>
#include <Atlas/Objects/Operation/Action.h>
#include <Atlas/Objects/Operation/Appearance.h>
#include <Atlas/Objects/Operation/Combine.h>
#include <Atlas/Objects/Operation/Communicate.h>
#include <Atlas/Objects/Operation/Create.h>
#include <Atlas/Objects/Operation/Delete.h>
#include <Atlas/Objects/Operation/Disappearance.h>
#include <Atlas/Objects/Operation/Divide.h>
#include <Atlas/Objects/Operation/Error.h>
#include <Atlas/Objects/Operation/Feel.h>
#include <Atlas/Objects/Operation/Get.h>
#include <Atlas/Objects/Operation/Imaginary.h>
#include <Atlas/Objects/Operation/Info.h>
#include <Atlas/Objects/Operation/Listen.h>
#include <Atlas/Objects/Operation/Login.h>
#include <Atlas/Objects/Operation/Logout.h>
#include <Atlas/Objects/Operation/Look.h>
#include <Atlas/Objects/Operation/Move.h>
#include <Atlas/Objects/Operation/Perceive.h>
#include <Atlas/Objects/Operation/Perception.h>
#include <Atlas/Objects/Operation/RootOperation.h>
#include <Atlas/Objects/Operation/Set.h>
#include <Atlas/Objects/Operation/Sight.h>
#include <Atlas/Objects/Operation/Smell.h>
#include <Atlas/Objects/Operation/Sniff.h>
#include <Atlas/Objects/Operation/Sound.h>
#include <Atlas/Objects/Operation/Talk.h>
#include <Atlas/Objects/Operation/Touch.h>

#include <sigc++/signal_system.h>


/**Message dispatcher.
   This is an equivalent to Atlas::Message::Decoder; but instead of
   virtual functions this class' interface provides signals for each 
   type of known object.
*/
class MsgDispatch : public Atlas::Message::DecoderBase, virtual public SigC::Object
{
 public:
  ///
  MsgDispatch();
  /// 
  virtual ~MsgDispatch();
  
 protected:
  /// Overridden by Objects::Decoder to retrieve the object.
  virtual void ObjectArrived(const Atlas::Message::Object&);

 public:  
  ///
  SigC::Signal1<void,const Atlas::Message::Object&> UnknownObjectArrived;
  
  /// A Root object has arrived.
  SigC::Signal1<void,const Atlas::Objects::Root&> RootObjectArrived;
  
  SigC::Signal1<void,const Atlas::Objects::Entity::Account&> EntityAccountArrived;
  SigC::Signal1<void,const Atlas::Objects::Entity::Admin&> EntityAdminArrived;
  SigC::Signal1<void,const Atlas::Objects::Entity::AdminEntity&> EntityAdminEntityArrived;
  SigC::Signal1<void,const Atlas::Objects::Entity::Game&> EntityGameArrived;
  SigC::Signal1<void,const Atlas::Objects::Entity::GameEntity&>
		EntityGameEntityArrived;
	SigC::Signal1<void,const Atlas::Objects::Entity::Player&> EntityPlayerArrived;
  SigC::Signal1<void,const Atlas::Objects::Entity::RootEntity&> EntityRootEntityArrived;
  
  SigC::Signal1<void,const Atlas::Objects::Operation::Action&> OpActionArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Appearance&> OpAppearanceArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Combine&> OpCombineArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Communicate&> OpCommunicateArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Create&> OpCreateArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Delete&> OpDeleteArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Disappearance&> OpDisappearanceArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Divide&> OpDivideArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Error&> OpErrorArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Feel&> OpFeelArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Get&> OpGetArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Imaginary&> OpImaginaryArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Info&> OpInfoArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Listen&> OpListenArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Login&> OpLoginArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Logout&> OpLogoutArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Look&> OpLookArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Move&> OpMoveArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Perceive&> OpPerceiveArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Perception&> OpPerceptionArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::RootOperation&> OpRootOperationArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Set&> OpSetArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Sight&> OpSightArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Smell&> OpSmellArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Sniff&> OpSniffArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Sound&> OpSoundArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Talk&> OpTalkArrived;
  SigC::Signal1<void,const Atlas::Objects::Operation::Touch&> OpTouchArrived;

};
