#ifndef _WF_NET_H_
#define _WF_NET_H_

#include <string>
#include <list>

#include "dii/object.h"

///
class WFNetwork
{
 public:
  ///
  enum 
  { 
    GAMESERVER_PORT = 6767,
    METASERVER_PORT = 8453
  };
  
  ///
  WFNetwork() {};
  ///
  ~WFNetwork() {};

  ///use other server then metaserver.worldforge.org
  static void useMetaServer(const std::string& hostname, int port = METASERVER_PORT);
  ///query list of servers currently running a worldforge game
  static std::list<std::string> queryGameServers();
  /** Query server for status informations.
      This establishes a TCP connection to the server machine at
      the given port and sends a Get Operation.
      The method returns the received information as  or DII::FAILURE
      if the request timed out.
      If successfully the received map object contains an additional entry called
      "ping" which gives the ping time in ms.
  */
  static DII::Object WFNetwork::queryServer(const std::string& hostname, int port);

 protected:
  ///default is metaserver.worldforge.org
  static std::string metaServer;
  ///default is WFNetwork::METASERVER_PORT
  static int metaPort;

};

#endif // !_WF_NET_H_

