//  The Worldforge Project
//  Copyright (C) 1998, 1999 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 01/2000

#include "decoders.h"

#ifndef _LOBBY_H_
#define _LOBBY_H_

#include "decoders.h"

class Lobby : virtual public SigC::Object
{
 public:
  ///
  Lobby();
  ///
  virtual ~Lobby() {};
  
  ///
  void processSightOp(const Atlas::Objects::Operation::Sight& sight);
  ///
  void processSoundOp(const Atlas::Objects::Operation::Sound& sound);
  ///
  void processAppearanceOp(const Atlas::Objects::Operation::Appearance& appear);
  ///
  void processDisappearanceOp(const Atlas::Objects::Operation::Disappearance& disappear);


 protected:
  ///
  SightDecoder sightDecoder_;
  ///
  SoundDecoder soundDecoder_;    
  ///
  void processSoundTalk(const Atlas::Objects::Operation::Talk&);    
  ///
  void processSight(const Atlas::Message::Object&);
  ///
	// Accounts correspond to out-of game accounts, which can have 
	// multiple ingame players (GameEntities)
  void processSightAccount(const Atlas::Objects::Entity::Account&);
	///
	// GameEntities correspond to ingame players
	void processGameEntity(const Atlas::Objects::Entity::GameEntity&);
 
  ///id -> name mapping
  std::map<std::string, std::string> players_;
  ///
  bool gettingList_;

};                                                   


#endif
