-- this script gets loaded at UClient startup, it allows easy customization

function loadModul(name)
   arg = { name }
   settag(arg, List_tag)
   DII_callService("mod_load", arg)
end

function loadScript(name)
   arg = { name }
   settag(arg, List_tag)
   DII_callService("script_load", arg)
end

function loadMaps()
   mydebug("loading maps  ... ") 
   arg[0]= "moraf_ne" 
   arg[1]= "100"
   arg[2]= "100"
   DII_callService("readMapFile", arg)

   arg[0]= "moraf_nw" 
   arg[1]= "-100"
   arg[2]= "100"
   DII_callService("readMapFile", arg)

   arg[0]= "moraf_se" 
   arg[1]= "100"
   arg[2]= "-100"
   DII_callService("readMapFile", arg)

   arg[0]= "moraf_sw" 
   arg[1]= "-100"
   arg[2]= "-100"
   DII_callService("readMapFile", arg)

   arg[0]= "moraf" 
   DII_callService("readXmlMapFile", arg)

   mydebug("[loading maps done]\n")

end

-- init this module
function init()
   mydebug("in Init::init() ....\n")

   -- load binary modules
   --
   mydebug("loading modules  ... ")
   loadModul("Console")
   loadModul("Viewport")
   loadModul("Renderer")

   loadModul("Inventory")
   loadModul("Player")
   loadModul("Observer")
   mydebug("[loading modules done]\n")
  
   -- load scripted modules
   --
   mydebug("loading scripts  ... ") 
   loadScript("TestCmds")	
   loadScript("selectserver")
   loadScript("minipanel")
   loadScript("main_menu")
   -- loadScript("inventory")
   loadScript("daylight")
   loadScript("observ")
   loadScript("status_ind")
   loadScript("mana_ind")
   loadScript("browser")
   mydebug("[loading scripts done]\n")

   -- loadMaps()   

   return 1
end

-- shutdown the module
function deinit()
   return 1
end

  
-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
mydebug ("Init.lua successfully loaded.\n")

-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")




