
function bugreport()
   -- send out bugreport ...

   -- must be provided by uclient user
   local server = Module_getOption("mail_server")
   local from = Module_getOption("from")
   if server == nil or from == nil then
      DII_callService("std_out", "For bugreport to work you must set bugreport::from "..
				"and bugreport::mail_server in settings.ini or via /set !\n")
      return
   end

   local to = Module_getOption("to")
   local rcpt = nil
   if to then
      rcpt = { to }
   else
      rcpt = { "malcolm@worldforge.org" }
   end
   
   local body = "Uclient crashed !\n"
   local mime = { Subject =  "uclient automatic bugreport" } 

   DII_callService("std_out", "Sending bugreport to "..rcpt[1].." via "..server.."... ")  
   local error = smtp_mail(from, rcpt, mime, body, server)
   if error then 
      DII_callService("std_out",error)
   else
      DII_callService("std_out"," done.")
   end

end

-- init this module
function init()
   -- load SMTP implementation
   loadExtension("smtp.lua")
   return 1
end

-- shutdown the module
function deinit()
   return 1
end
		
-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")

REGISTER_METHOD("bugreport")
REGISTER_AS_SERVICE("bugreport")

NEEDS_MODULE("Gui")


