-- init this module
function init()
   return 1
end

-- shutdown the module
function deinit()
   return 1
end

-- a day has got 20*60*24 seconds = 28800 seconds
-- nighttime: 22:00 .. 05:00 (26400 .. 6000)
-- dawn     : 5:00 .. 8:00 (6000 .. 9600)
-- daytime  : 8:00 .. 19:00 (9600 .. 22800)
-- dusk     : 19:00 .. 22:1900 (22800 .. 26400)
--

day_gamma = 0
night_gamma = -30
dim_gamma = 0

function handler()

   local time = DII_callMethod("Player","getTime",0)

   if type(time) ~= "table" then return 0 end

   if not time.hour then time.hour = 0 end
   if not time.minute then time.minute = 0 end

   local ticks = time["minute"]*20 + time["hour"]*60*20;
   
   local gamma;

   if ticks <= 6000 or ticks > 26400 then
      gamma = night_gamma
   elseif ticks > 6000 and ticks <= 9600 then
      gamma = night_gamma + (day_gamma-night_gamma)*(ticks-6000)/3600
   elseif ticks > 9600 and ticks <= 22800 then
      gamma = day_gamma
   else
      gamma = day_gamma + (night_gamma - day_gamma)*(ticks-22800)/3600
   end

   mydebug("setting daylight to "..gamma+dim_gamma.."\n")

   DII_callMethod("Renderer","setGamma", gamma+dim_gamma)

   return 0
end

function dim(arg)
   local _arg = tonumber(arg)		
   if _arg then
      dim_gamma = _arg
      return 1
   end
   return 0
end

-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")
REGISTER_METHOD("dim")

NEEDS_MODULE("App")

-- App::signal() is emitted every second
--
DII_registerMsgHandler("App","handler")
