function dialogtest()

   txt = "running dialog test ...\n"
   DII_callService("std_out", txt)

   style = newJanusItem("style")
   data = newJanusItem("data")
   structure = newJanusItem("structure")
   logic = newJanusItem("logic")

   style.item1 = newJanusItem("property", { part="Label", height=25 })
   style.item2 = newJanusItem("property", { part="LineEdit", height=25 })

   structure.dialog1 = newJanusItem("Dialog", 
       { 
         x=100, y=100, width=500, height=300,
         label1 = newJanusItem("Label", 
            {
              x=10, y=10, width=300, 
              text = "Janus/LUA Test"
            }),
         label2 = newJanusItem("Label",
            {
              x=10, y=40, width=280, 
              text = "Login :"
            }),
         lineedit1 = newJanusItem("LineEdit",
            {
              x=10, y=40, width=300, 
	    }),
         button1 = newJanusItem("PushButton", 
            {
              x=380, y=150, width=100, height=25, 
              text="Ok"
            }),
         button2 = newJanusItem("PushButton", 
            {
              x=380, y=100, width=100, height=25, 
              text="Hello !"
            })
      })

   logic.conn1 = newJanusItem("connection", 
                            { sender="button1",   signal="clicked",
                              receiver="dialog1", slot="accept" })
   logic.conn2 = newJanusItem("connection",
                            { sender="button2",   signal="clicked",
                              receiver="dialog1", slot="dialogtest:sayHello" })
     
   dialog = newJanusItem("janus", 
                        { style=style, 
              		  data=data,  
              		  structure=structure, 
              		  logic=logic })
   
   id = DII_callMethod("Gui","create_dialog", dialog)

   if id == nil then return end

   DII_callService("std_out","got dialog id "..id.."\n")

   DII_callMethod("Gui","run_dialog", id)

   DII_callMethod("Gui","destroy_dialog", id)

end

function sayHello()
   DII_callService("std_out","Hello Bert !\n")
end

-- init this module
function init()

   loadExtension("janus.lua")

   dialogtest()
   return 1
end

-- shutdown the module
function deinit()
   return 1
end
		
-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")
REGISTER_METHOD("dialogtest")
REGISTER_METHOD("sayHello")

REGISTER_AS_SERVICE("dialogtest")

NEEDS_MODULE("Gui")


