-- globals

invdialog_id = ""
menu_button = {}

function inventory()
   local style = newJanusItem("style")
   local data = newJanusItem("data")
   local structure = newJanusItem("structure")
   logic = newJanusItem("logic")

   style.item1 = newJanusItem("property", { part="Label", height=25 })
   style.item2 = newJanusItem("property", { part="LineEdit", height=25 })
   style.item3 = newJanusItem("property", { part="Label", width=150 })
   style.item4 = newJanusItem("property", { part="PushButton", height=25 })
   style.item5 = newJanusItem("property", { part="PushButton", width=150 })
	
   data.transparent = newJanusItem("Color", {id="transparent", data="0 0 0 0"})
   data.shaded = newJanusItem("Color", {id="shaded", data = "0 0 0 128"})
   data.black = newJanusItem("Color", {id="black", data="0 0 0 255"})
   data.grey = newJanusItem("Color", {id="grey", data="128 128 128 255"})	
	

   structure.invdialog = newBorderedDialog(100,200,470,350)
   structure.invdialog.clientArea.background = "background";

   structure.invdialog.clientArea.heading = 
       newJanusItem("Label", { x=10, y=10,width=300, color="transparent", 
                               text = "INVENTORY"})
   
   local row = 0
   local col = 0
   local id = 1
   local hspace = 70
   local vspace = 80
   while row <  3 do
      col = 0
      while col < 6 do
         structure.invdialog.clientArea["slot_"..tostring(id)] = 
            newJanusItem("PushButton", { x=10+col*hspace,y=50+row*vspace,
                                         width=50,height=50,
                                         background="inv_square",id=id})
         id = id + 1
         col = col + 1
      end
      row = row + 1 
   end

   structure.invdialog.clientArea.butup = 
        newJanusItem("PushButton",{x=430,y=50,width=25, height=25, 
                                   image_up="arrow_up",image_down="arrow_up_pressed"})
   structure.invdialog.clientArea.butdown = 
        newJanusItem("PushButton",{x=430,y=50+3*hspace-25, width=25, height=25, 
                                   image_up="arrow_down",image_down="arrow_down_pressed"})

   structure.invdialog.clientArea.butclose = 
        newJanusItem("PushButton",{x=350,y=320,width=100,color="grey",text="Close"})


   logic.conn1 = newJanusItem("connection", 
                            { sender="butclose",   signal="clicked",
                              receiver="invdialog", slot="accept" })

   local dialog = newJanusItem("janus", 
                               { style=style, 
              	                 data=data,  
              		         structure=structure, 
              		         logic=logic})
   
   invdialog_id = DII_callMethod("Gui","create_dialog", dialog)

   if invdialog_id then 
      DII_callMethod("Gui","run_dialog", invdialog_id)
   else
      DII_callService("std_err","failed to create dialog !\n" )
   end

   if invdialog_id then 
      DII_callMethod("Gui","destroy_dialog", invdialog_id)
   end

end

--
--
function menuCallback(arg)
   if arg.args[1].id == menu_button.id then
     inventory()
   end
   return 0
end

-- init this module
function init()
   loadExtension("janus.lua")

   menu_button = DII_callMethod("Gui","bind_menubutton",0);
   --   menu_button.text = "I"
   menu_button.upPic = "mibutton";
   menu_button.downPic = "mibutton_pressed";   
   DII_callMethod("Gui","change_menubutton",menu_button);

   DII_registerMsgHandler("Gui","menuCallback")

   return 1
end

-- shutdown the module
function deinit()
   return 1
end
	
	
-- register to DII system
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")

REGISTER_METHOD("inventory")
REGISTER_AS_SERVICE("inventory")
