-- globals
--

-- TODO: Hardcoded things are BAD!  We'll need a solution that uses
-- entries in resources.ini or another globally referenced file in
-- order to provide anchors for these files.
screenarea = {}
widget_id = nil
portrait_table = { 

-- the fixme versions need to be replaced; consider doing it properly (see above)
watermage_male = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
guard_male = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
guard_female = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
farmer_male = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
farmer_female = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
druid_female = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
seller_male = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
khatinid_male = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
archer_female = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
settler_female = "/media/media-2d/collection-brent/ui/portraits/paladin_female_portrait_72x90.png",
settler_male = "/media/media-2d/char-collection-munin/MaleBuilder_portrait_ah_72x87.png",
_male = "/media/media-2d/collection-anon/ui/fixme-70x90.png",
_female = "/media/media-2d/collection-anon/ui/fixme-70x90.png"
}

-- build the widget
--
function createWidget(section)

   local desc = newJanusDescription()

   local prefix = DII_callService("readRegistryEntry", "/install_dir").."/forge";
   
   local filename = "/media/media-2d/collection-malcolm/ui/stone/panel_char_mason_silver_1_72x90_mw.png"

   desc.data.char_background = 
      newJanusItem("Image",{ type="file",
                             id="char_background",
			     source=prefix..filename } )

   desc.structure.root = newJanusItem("Widget", section)
   desc.structure.root.background="char_background"

   local id = DII_callMethod("Gui","create_dialog",desc)     	
   
   if id == nil then 
      print("minipanel: failed to create Widget !") 
      return 
   end

   return id
end

-- add new image to resource db
--
function newPortrait(type, gender)

   local _id;
   if type and gender then 
      _id = type.."_"..gender 
   elseif gender then 
      _id = "_"..gender 
   else 
      _id = "_male"
   end

   local prefix = DII_callService("readRegistryEntry", "/install_dir").."/forge";
   
   local filename = portrait_table[_id]

   if not filename then
       mydebug("could not find portrait table entry for \"".._id.."\"!\n")
       filename = portrait_table["_male"]
   end

   -- tricky use of Janus ...
   -- 
   -- 1) create a dialog description which only defines a single resource
   -- 2) destroy the dialog immediately
   -- ... the resource stays loaded and can be used afterwards :)
   --
   local desc = newJanusDescription()
   desc.data.main_background = 
      newJanusItem("Image",{ type="file",
                             id="portrait_".._id,
			     source=prefix..filename } )

   -- Win32 Janus crashes with no structure
   desc.structure.root = newJanusItem("Widget", section)	
   local id = DII_callMethod("Gui","create_dialog",desc)   
   DII_callMethod("Gui","destroy_dialog",id)

   -- return id of the newly loaded resource
   return "portrait_".._id
end

-- init this module
--
function init()
 
   loadExtension("janus.lua")

   screenarea = bindScreenSection(3)
   
   if screenarea == nil then return 0 end

   widget_id = createWidget(screenarea)
 
   return 1
end

-- shutdown the module
--
function deinit()
   if widget_id then
      DII_callMethod("Gui","destroy_dialog",widget_id)
   end
   if screenarea then
      DII_callMethod("Gui","release_screenarea",screenarea)
   end
   return 1
end

	
function slot_player(arg)

   if type(arg)  ~= "table" then 
      return 0
   end
   
   if widget_id == nil then return end

   if arg.event == "gotcharacter" then
	  
      mydebug("minipanel::slot_player event="..arg.event.."\n")
   
      local charID = DII_callMethod("Player","currentCharacterID",0)
      local char = DII_callMethod("Player","queryMemory",charID)
     
      local portrait_id = newPortrait(char.parents[1], char.sex)

      mydebug("minipanel::slot_player setting new background image ...")
      local param = DII_newMap( { id=widget_id, sub_id="root", 
                                 attributes= DII_newMap({ background = portrait_id}) } )
      DII_callMethod("Gui","change_dialog",param) 
      mydebug(" OK.\n")

   end
   return 0
end
	
-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")

NEEDS_MODULE("Gui")

-- connect the signal of module "Player" to the function "slot_player"
-- 
DII_registerMsgHandler("Player","slot_player")
