-- init this module
function init()
   return 1
end

-- shutdown the module
function deinit()
   return 1
end

function mouseHandler(arg)
   if type(arg) ~= "table" then return 0 end
   if arg.from ~= "Renderer" then return 0 end

   if arg.event == "rightclicked" then
      if arg.entity then
	 -- print ID to screen
	 DII_callService("std_out", "This is ID "..arg.entity..".\n")
	 -- query Player's memory about this ID
	 entity = DII_callMethod("Player","queryMemory",arg.entity)
	 -- if entity != nil then
	 if entity then
	    if entity.name then
	       DII_callService("std_out","Its name is "..entity.name..".\n")
	    end
	 end
      else	
	txt = "This is Position ("..arg.coords[1]..", "..arg.coords[2]..", "..arg.coords[3]..").\n"
	DII_callService("std_out", txt)
      end
      return 0
   end
   -- returning 0 (=false) enables this event to get processed by others (or the default handler)
   return 0
end
		
-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")

-- connect the signal of module "Renderer" to the function "mouseHandler"
-- Renderer emits signals for each mouseclick which are handled by "mouseHandler"
--
-- in C++ you would write (no error handling !):
--	DII::lookupModule("Renderer")->signal.connect(SigC::slot(this,&CLASS::mouseHandler));
--
DII_registerMsgHandler("Renderer","mouseHandler")

