-- Server Browser
--
-- written by Karsten Laux in April 2001

server_table = {}
dialog_entries = {}
dialog_id = nil
login_dialog_id = nil
PROVIDE_HOST = 1000

-- needs to be global ... FIXME !!
logic = {}

-- query metaserver for a list of running servers, then ask
-- each individual server for detailed informations
-- 
function getServerInfos()

   local id = DII_callMethod("Gui","open_progressbar","Querying WF Network for game servers ...")   

   DII_callService("std_out","Querying metaserver for server list ... ")
   local servers = DII_callMethod("Player","queryServerList",0)
   local count = getn(servers)
   DII_callService("std_out"," got "..tostring(count).." running servers.\n")

   local update={}
   update[0]=id
   update[1]=25
   settag(update, List_tag)
   DII_callMethod("Gui","update_progressbar", update)

   local server_infos = {}

   -- fast return if no running servers found 
   if count == 0 then 
       DII_callMethod("Gui","close_progressbar", id)
       return server_infos 
   end

   DII_callService("std_out","Querying individual servers for detailed information ...\n")
   local itr, val  = next(servers,nil)

   local count = getn(servers)
   local n = 0;
   while itr do
      local address = tostring(val)
      assert(address)
      local arg = {}
      arg[0] = address;
      settag(arg, List_tag)
      DII_callService("std_out","    "..address.." ... ")
      server_infos[address] = DII_callMethod("Player","queryServer", arg)

      n=n+1
      local update={}
      update[0]=id
      update[1]=25+(n*75)/count
      settag(update, List_tag)
      DII_callMethod("Gui","update_progressbar", update)

      if tag(server_infos[address]) == Map_tag then
         DII_callService("std_out"," Ok.\n")
      else 
         DII_callService("std_out"," connection timed out.\n")
      end
      itr, val = next(servers, itr)
   end

   DII_callMethod("Gui","close_progressbar", id)

   return server_infos
end

function createTableHeader()
   
   local widget = newJanusItem("Widget", { y=0, width = 500, 
				     height=30, color="transparent"})
   
   widget["_name"] = newJanusItem("Label", {x=0, width = 180, color="transparent", 
                                            background="", text="Server", button=row})

   widget["_ruleset"] = newJanusItem("Label",{x=200, width=100, 
                                              text="Ruleset", color="transparent"})
   
   widget["_clients"] = newJanusItem("Label",{x=300,width=70, 
                                              text="Clients", color="transparent"})
   
   widget["_uptime"] = newJanusItem("Label",{x=370, width=70, 
                                           text="Uptime", color="transparent"})

   widget["_ping"] = newJanusItem("Label",{x=440, width=60, 
                                           text="Ping", color="transparent"})


   return widget
end

function createTableRow(row, server_name, server_info)
   
   assert(type(server_name) == "string")
   assert(type(server_info) == "table")

   mydebug("row="..tostring(row).." y="..tostring(35+row*30).."\n")

   local widget = newJanusItem("Widget", { y=(35 + row*30) , width = 500, height=30, 
                                     color="transparent"})
   widget[server_name.."_name"] = 
       newJanusItem("PushButton", { width = 115, color="grey", 
                                    text=server_name, button=row})
   logic[server_name.."_cb"] = 
       newJanusItem("connection", { sender=server_name.."_name",   signal="clicked",
                                    receiver="dialog1", slot="selectserver:slot_select" })

   ruleset = tostring(server_info.ruleset)
   widget[server_name.."_ruleset"] = 
       newJanusItem("Label",{x=200, width=100, text=ruleset, color="transparent"})
   
   clients = tostring(server_info.clients)
   widget[server_name.."_clients"] = 
       newJanusItem("Label",{x=300,width=70, text=clients, color="transparent"})

-- uptime  = tostring(server_info.uptime / 3600)
   local tmp = server_info.uptime / 3600
   uptime = format("%1$3.1f hrs",tmp)
   widget[server_name.."_uptime"] = 
       newJanusItem("Label",{x=370, width=70, text=uptime, color="transparent"})
  
   ping = tostring(server_info.ping).." ms"
   widget[server_name.."_ping"] = 
       newJanusItem("Label",{x=440, width=70, text=ping, color="transparent"})

   return widget
end
      
function createTable(infos)
   assert(type(infos) == "table")

   local widget = newJanusItem("Widget", { width = 500, height = 350, color="transparent" })
   widget["header"] = createTableHeader()

   local itr, val = next(infos, nil)
   local row = 0
   while (itr ~= nil) and (row < 10) do
       id = "row_"..tostring(row)
       widget[id] = createTableRow(row, tostring(itr), val)
       dialog_entries[row] = tostring(itr);
       itr,val = next(infos, itr)
       row = row + 1
   end
   return widget
end
 
function createDialog(infos)

--   if dialog_id then 
--      DII_callMethod("Gui","run_dialog", dialog_id)
--      return
--   end

   local style = newJanusItem("style")
   local data = newJanusItem("data")
   local structure = newJanusItem("structure")
   logic = newJanusItem("logic")

   style.item1 = newJanusItem("property", { part="Label", height=25 })
   style.item2 = newJanusItem("property", { part="LineEdit", height=25 })
   style.item3 = newJanusItem("property", { part="Label", width=150 })
   style.item4 = newJanusItem("property", { part="PushButton", height=25 })
   style.item5 = newJanusItem("property", { part="PushButton", width=115 })
	
   data.transparent = newJanusItem("Color", {id="transparent", data="0 0 0 0"})
   data.shaded = newJanusItem("Color", {id="shaded", data = "0 0 0 128"})
   data.black = newJanusItem("Color", {id="black", data="0 0 0 255"})
   data.grey = newJanusItem("Color", {id="grey", data="128 128 128 255"})	
	

   structure.dialog1 = newBorderedDialog(140,75,520,450)
   structure.dialog1.clientArea.background = "background";

   structure.dialog1.clientArea.heading = 
       newJanusItem("Label", { x=10, y=10,width=300, color="transparent", 
                               text = "RUNNING WORLDFORGE SERVERS:"})
  
   structure.dialog1.clientArea.table = createTable(infos)
   structure.dialog1.clientArea.table.y = 40;
   structure.dialog1.clientArea.table.x = 10;

   structure.dialog1.clientArea.button0 = newJanusItem("PushButton",{x=10,y=420,color="grey",
                                                        text="Specify Host",button=PROVIDE_HOST})

   structure.dialog1.clientArea.button1 = newJanusItem("PushButton",{x=395,y=420,color="grey",
                                                        text="Cancel"})

   logic.conn1 = newJanusItem("connection", 
                            { sender="button1",   signal="clicked",
                              receiver="dialog1", slot="reject" })
   logic.conn2 = newJanusItem("connection", 
                            { sender="button0",   signal="clicked",
                              receiver="dialog1", slot="selectserver:slot_select" })

   local dialog = newJanusItem("janus", 
                               { style=style, 
              	                 data=data,  
              		         structure=structure, 
              		         logic=logic})
   
   dialog_id = DII_callMethod("Gui","create_dialog", dialog)

   if dialog_id then 
      DII_callMethod("Gui","run_dialog", dialog_id)
   else
      DII_callService("std_err","failed to create dialog !\n" )
   end

  if dialog_id then 
      DII_callMethod("Gui","destroy_dialog", dialog_id)
   end
 
   dialog_id = nil
end



-- Gets called when user selects one of the table rows, the 
-- argument is meant to be the number of the row
--
function slot_select(arg)
    mydebug(" ... reached selectserver::slot_select()\n")
    
    local hostname = ""
		local hostname2 = ""
    local req = {}

    if tonumber(arg.value) == PROVIDE_HOST then
        req = { section="server", key="hostname" }
        settag(req, Map_tag)
        hostname = DII_callMethod("Settings","getItem", req)
	-- replace "_" by "."
        if hostname then
	   hostname2 = gsub(hostname,'_','.')
		        mydebug ("Converted "..hostname.." to "..hostname2.." \n")
            hostname = hostname2 
        end
    else
       mydebug("Row "..arg.value.." has been selected !\n")
	
       local row = tonumber(arg.value);
       hostname = dialog_entries[row];

       mydebug("row number "..tostring(row).." maps to host "..hostname.."\n")
    end
    
    req = { section="server", key="login" }
    settag(req, Map_tag)
    local login = DII_callMethod("Settings","getItem", req)
		
    -- open login dialog

   local style = newJanusItem("style")
   local data = newJanusItem("data")
   local structure = newJanusItem("structure")
   local logic = newJanusItem("logic")


   data.transparent = newJanusItem("Color", {id="transparent", data="0 0 0 0"})	
   data.shaded = newJanusItem("Color", {id="shaded", data = "0 0 0 32"})

   local dialog = newBorderedDialog(200,200,400,200)
   dialog.clientArea.background = "background";

   dialog.clientArea.heading = newJanusItem("Label", { x=10, y=10,width=380, color="transparent", 
                                                       text = "LOGIN ON THE GAMESERVER:"})

   dialog.clientArea.label1 = newJanusItem("Label", { x=10, y=40, width=150, color="transparent",
                                                      text = "Host:"});
   dialog.clientArea.hostname = newJanusItem("LineEdit", { x=170, y=40, width=200, color="shaded", 
                                                           text = hostname}) 	   

   dialog.clientArea.label2 = newJanusItem("Label", { x=10, y=70, width=150, color="transparent",
                                                      text = "Login Name:"});
   dialog.clientArea.login = newJanusItem("LineEdit", { x=170, y=70, width=200, color="shaded"}) 
   if login then
      dialog.clientArea.login.text = login
   end

   dialog.clientArea.label3 = newJanusItem("Label", { x=10, y=100, width=150, color="transparent",
                                                      text = "Password:"});
   dialog.clientArea.password = newJanusItem("LineEdit", { x=170, y=100, width=200, color="shaded"}) 

   dialog.clientArea.connect = newJanusItem("PushButton", { x=10, y=170, width=115, height=25,
                                                            color="transparent", text="Login" })
   dialog.clientArea.create = newJanusItem("PushButton", { x=140, y=170, width=115, height=25,
                                                            color="transparent", text="New Account" })
   dialog.clientArea.cancel = newJanusItem("PushButton", { x=270, y=170, width=115, height=25,
                                                            color="transparent", text="Cancel" })
   structure.dialog = dialog;

   logic.conn1 = newJanusItem("connection", 
                            { sender="cancel",   signal="clicked",
                              receiver="dialog", slot="reject" })

   logic.conn2 = newJanusItem("connection", 
                             { sender="connect",   signal="clicked",
                              receiver="dialog", slot="selectserver:slot_connect" })

   logic.conn3 = newJanusItem("connection", 
                             { sender="create",   signal="clicked",
                              receiver="dialog", slot="selectserver:slot_create" })


   local dialog = newJanusItem("janus", 
                               { style=style, 
              	                 data=data,  
              		         structure=structure, 
              		         logic=logic})
   
   login_dialog_id = DII_callMethod("Gui","create_dialog", dialog)

   if login_dialog_id then 
      DII_callMethod("Gui","run_dialog", login_dialog_id)
   else
      DII_callService("std_err","failed to create login dialog !\n" )
   end

   if login_dialog_id then 
      DII_callMethod("Gui","destroy_dialog", login_dialog_id)
   end

   return 1
end

--
--
function slot_connect(arg)
    mydebug(" ... reached selectserver::slot_connect()\n")
    if arg  == nil then return 0 end

    mydebug("Attempting login at "..arg.hostname.." using "..arg.login..":"..arg.password.."\n")

    local req = { section="server", key="login", value=arg.login }
    settag(req, Map_tag)
    DII_callMethod("Settings","setItem", req);
    -- replace inside the hostname "." with "_"
    req = { section="server", key="hostname", 
            value = gsub(arg.hostname,"%.","_") }
    settag(req, Map_tag)
    DII_callMethod("Settings","setItem", req);

    param = {id=arg.login, password=arg.password, hostname=arg.hostname}
    settag(param, Map_tag)

    local connected =  DII_callMethod("Player","login",param);

    if connected then 
       -- close all dialogs
       --
       call ={ id=login_dialog_id, sub_id="dialog", cmd="accept", arg="" }
       settag(call, Map_tag)
       DII_callMethod("Gui","call_dialog",call)
    
       call = {id=dialog_id, sub_id="dialog1", cmd="accept", arg="" }
       settag(call, Map_tag)
       DII_callMethod("Gui","call_dialog",call)
     
    else
      -- else popup error message
      --
      local arg = { title="Error", message="Failed to connect to server.\n"..
                                           "Did you provide the correct username and password ?" }
      settag(arg, Map_tag)
      DII_callMethod("Gui","popup_messagebox",arg)
   end

   return 1
end

--
--
function slot_create(arg)
    mydebug(" ... reached selectserver::slot_create()\n")
    if arg  == nil then return 0 end 

    mydebug("going to create new account at "..arg.hostname.." using "..arg.login..":"..arg.password.."\n")

    local req = { section="server", key="login", value=arg.login }
    settag(req, Map_tag)
    DII_callMethod("Settings","setItem", req);
    req = { section="server", key="hostname", value=arg.hostname }
    settag(req, Map_tag)
    DII_callMethod("Settings","setItem", req);

    param = {id=arg.login, password=arg.password, hostname=arg.hostname}
    settag(param, Map_tag)
    local connected = DII_callMethod("Player","createAccount",param);

    if connected then 
       -- close all dialogs
       --
       call ={ id=login_dialog_id, sub_id="dialog", cmd="accept", arg="" }
       settag(call, Map_tag)
       DII_callMethod("Gui","call_dialog",call)
    
       call = {id=dialog_id, sub_id="dialog1", cmd="accept", arg="" }
       settag(call, Map_tag)
       DII_callMethod("Gui","call_dialog",call)
     
    else
      -- else popup error message
      --
      local arg = { title="Error", message="Failed to create a new account.\n"..
                                           "The provided username is already in use." }
      settag(arg, Map_tag)
      DII_callMethod("Gui","popup_messagebox",arg)
   end

   return 1
end


-- User command
--
function browseServers()
   server_table = getServerInfos()
   createDialog(server_table)
   return 1
end



-- init this module
function init()

   loadExtension("janus.lua")

   return 1
end

-- shutdown the module
function deinit()
   if dialog_id then 
      DII_callMethod("Gui","destroy_dialog", dialog_id)
   end
   return 1
end
		
-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")
REGISTER_METHOD("browseServers")
REGISTER_METHOD("slot_select")
REGISTER_METHOD("slot_connect")
REGISTER_METHOD("slot_create")

-- these methods can be called as user commands
REGISTER_AS_SERVICE("browseServers")

-- we want to display dialogs and thus we need Gui
NEEDS_MODULE("Gui")


