-- globals
widget_id = ""
screen_section = nil

-- build the inventory widget
function createWidget(section)

   local desc = newJanusDescription()
   
   desc.style.style1 = 
      newJanusItem("property", {part="Widget", color="200 200 200"})

   desc.structure.root = newJanusItem("Widget", section)

   desc.structure.root.button1 =
      newJanusItem("PushButton", {x=10,y=10,width=50, height=50, background=""})

   local id = DII_callMethod("Gui","create_dialog",desc)     	
   
   if id == nil then 
      print("Inventory: failed to create Widget !") 
      return 
   end

   return id
end

-- init this module
function init()
   loadExtension("janus.lua")

   screen_section = bindScreenSection(1)
   if screen_section == nil then 
      print("Inventory: cannot bind to screen !") 
      return 0 
   end

   widget_id = createWidget(screen_section)
   if widget_id == nil then return 0 end
   
   DII_callMethod("Gui","show_dialog", widget_id)
	
   return 1
end

-- shutdown the module
function deinit()
   if widget_id then
      DII_callMethod("Gui","hide_dialog", widget_id)
      DII_callMethod("Gui","destroy_dialog",widget_id)
   end
   if screen_section then
      releaseScreenSection(screen_section)
   end
   return 1
end
	
	
-- register to DII system
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")
