-- globals
--
screenarea = {}
widget_id = nil

-- maximum height of the status bar
bar_height = 0
saved_status = 0

--
characterID = nil

-- build the widget
--
function createWidget(section)

   local desc = newJanusDescription()

   desc.structure.statusInd = newJanusItem("Widget", section)
--   desc.structure.statusInd.sep = newJanusItem("Widget",{width=8, height=section.height})
--   desc.structure.statusInd.sep.background="seperator_v"
   desc.structure.statusInd.ind = newJanusItem("Widget",{width=43, height=section.height})
   desc.structure.statusInd.ind.background="health_background"
   
   -- partially overlay the filled background with the image of the empty
   -- bar ... cool idea, Pegasus !
   desc.structure.statusInd.ind.empty = newJanusItem("Widget",{width=43, height=30})
   desc.structure.statusInd.ind.empty.background="health_empty"

   -- this is not 100% correct as the status bar does not cover
   -- the complete height of the image ..
   bar_height = section.height

   local id = DII_callMethod("Gui","create_dialog",desc)     	
   
   if id == nil then 
      print("status_ind: failed to create Widget !") 
      return 
   end

   return id
end

-- change the status bar
--
function update_statusbar(status)
   if widget_id then
         if status > 1 then status = 1 end
         if status < 0 then status = 0 end
         height = bar_height * status;
	 local call ={ id=widget_id, sub_id="empty", cmd="resize", arg="43 "..tostring(height) }
         settag(call, Map_tag)
         DII_callMethod("Gui","call_dialog",call)
   end
   return 1
end


function handler(arg)

   if type(arg)  ~= "table" then 
      return 0
   end
   
   if widget_id == nil then return end
   
   if arg.from == "Oberser" and arg.event == "changed" then
      local entity = arg.args[1]
      if entity.id == characterID then
         local status = entity.status
         if status and status ~= saved_status then
            saved_status = status 
            update_statusbar(status)         
         end
      end
   end

   if arg.from == "Player" and arg.event == "gotcharacter" then
      if characterID then DII_callMethod("Observer", "removeID", characterID) end
      characterID = DII_callMethod("Player","currentCharacterID",0)
      DII_callMethod("Observer","addID", characterID)
   end
   return 0
end

-- init this module
--
function init()
 
  loadExtension("janus.lua")

   -- some magic ... section 4 is the left status bar
  screenarea = bindScreenSection(4)
   
  if screenarea == nil then print("status_ind failed to obtain screenarea !\n") return 0 end

  widget_id = createWidget(screenarea)
 
   return 1
end

-- shutdown the module
--
function deinit()
  if widget_id then
     DII_callMethod("Gui","destroy_dialog",widget_id)
  end
  if screenarea then
     DII_callMethod("Gui","release_screenarea",screenarea)
  end
        
  if characterID then DII_callMethod("Observer", "removeID", characterID) end

   return 1
end



-- all following lines are "global" code and executed as soon
-- as the script has been loaded and compiled
--
-- the semantics of the calls are the same as for binary modules,
-- just the name of the module is omitted
-- (see README.modules)
--
REGISTER_METHOD("init")
REGISTER_METHOD("deinit")

NEEDS_MODULE("Gui")
NEEDS_MODULE("Observer")
NEEDS_MODULE("Player")

-- connect the signal of module "Observer" to the function "handler"
-- (in order to observ the player character)
DII_registerMsgHandler("Observer","handler")

-- connect the signal of module "Player" to the function "handler"
-- (in order to catch gotcharacter events and to retrieve the
--  character id) 
DII_registerMsgHandler("Player","handler")
