//  The Worldforge Project
//  Copyright (C) 1998, 1999,2000,2001 The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 05/2001

#ifdef __cplusplus
extern "C" {
#endif

typedef unsigned short uint16;
typedef short sint16;
typedef unsigned char uint8;
typedef char sint8;

typedef struct
{
  uint8* pixels;
  sint16 pitch;
  sint16 width;
  sint16 height;
} Stretch_TargetSurface;

typedef struct
{
  uint8* pixels;
  sint16 pitch;
  sint16 offset_x;
  sint16 offset_y;
  uint16 transColor;
} Stretch_SrcSurface;

typedef struct
{
  sint16 offset_x, offset_y;
  sint16 h0,h1,h2,h3;
  sint8 sl0, sl1, sl2, sl3;
} Stretch_Args;

void Stretch_setShadingTarget(sint8* target);

void Stretch_setSource(Stretch_SrcSurface* source);

void Stretch_setTarget(Stretch_TargetSurface* target);

void Stretch_blit(Stretch_Args* args);

void LeftOverlap_blit(Stretch_Args* args, sint16 overlap);

void RightOverlap_blit(Stretch_Args* args, sint16 overlap);





#ifdef __cplusplus
}
#endif
