//  The Worldforge Project
//  Copyright (C) 2002 Ron Steinke and The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Ron Steinke 2/17/2001

// This code is intended as a replacement for the work done by the
// Endpoint class in the SOLID library, previously used here

#ifndef _BOX_LIST_H_
#define _BOX_LIST_H_

#include <list>
#include "Box.h"
#include "Encounter.h"

class BoxList : private list<Box*> {
  public:
    void move(list<Box*>::iterator &i, int axis, Scalar shift);
    list<Box*>::iterator add(Box& b, int axis);
    void remove(list<Box*>::iterator &i) {erase(i);}
};

// Declare these here, they're defined in C-api.cpp
void addPair(ObjectPtr object1, ObjectPtr object2);
void removePair(ObjectPtr object1, ObjectPtr object2);

#endif
  
