///////////////////////////////////////////////////////////////////////////
//                                  dtags.h
//
// Copyright (c) 1996 Bryce W. Harrington
// - bryce@netcom.com - bryce@alumni.caltech.edu - bryce@python.sp.trw.com
// = http://www.alumni.caltech.edu/~bryce = http://www.genealogy.org/~bryce
//
//-----------------------------------------------------------------------
// License:  This code may be used by anyone for any purpose
//           so long as the copyright notices and this license
//           statement remains attached.
//-----------------------------------------------------------------------
// Description of file
//  This is a simple debug message system.
//
//----------------------------------------------------------------------//
// MODIFICATION HISTORY
//
// June 1993 - Bryce W. Harrington
//   Created DTAGS facility as part of the basicdefs.h include file
//
// October 1996 - Bryce W. Harrington
//   Broke out DTAGS into its own file
//
// July 1999
//   added console fluff for qserver2 (sdt@gmx.net)
//
//////////////////////////////////////////////////////////////////////////

#ifndef dtags_h
#define dtags_h


#ifdef CONSOLE
#include "Console.h"
extern Console* console;
#endif


//#define DEBUG_TAG

#ifdef DEBUG_TAG

#ifdef CONSOLE
#define DTAG( msg )		console->PostMsg((string)"GENERAL", \
		 		(string)"DBUG: "+ (string)msg);
#define D2TAG( msg, a )		console->PostMsg((string)"GENERAL", \
				(string)"DBUG: "+ (string)msg + \
				(string)" "+ (string)a);
#define D3TAG( msg, a, b )	console->PostMsg((string)"GENERAL", \
				(string)"DBUG: "+ (string)msg + \
				(string)" "+ (string)a + (string)" " + \
				(string)b);
#define FATAL( msg )            console->PostMsg((string)"GENERAL", \
				(string)"OUCH: ["+ (string)__FILE__ + \
                                (string)" Fatal Error]: " + (string)msg);
#define ASSERT( test, msg )    if (!(test)) { \
                                console->PostMsg((string)"GENERAL", \
				(string)"OUCH: ["+ (string)__FILE__ + \
                                (string)" Failed Assert]: "+ (string)msg); }

#else

#define DTAG( msg )		cerr << msg << endl;
#define D2TAG( msg, a )		cerr << msg << " " << a << endl;
#define D3TAG( msg, a, b )	cerr << msg << " " << a << " " << b << endl;
#define FATAL( msg )            cerr << __FILE__ << ":" << __LINE__ \
                                     << "  Fatal Error: " << msg << endl;
#define ASSERT( test, msg )    if (!(test)) { \
                                   cerr << __FILE__ << ":" << __LINE__ \
                                        << "  Failed Assert: " << msg << endl; }
#endif
#else
#define DTAG( msg )
#define D2TAG( msg, a )
#define D3TAG( msg, a, b )
#define FATAL( msg )
#define ASSERT( test, msg )
#endif

#endif // dtags.h
// END
