//w
//
//  The Worldforge Project
//  Copyright (c) 2002  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the WorldForge Web Site at http://www.worldforge.org.
//
//  Created by Ron Steinke, 5/24/2002
///

#ifndef LOCAL_HASH_MAP_H
#define LOCAL_HASH_MAP_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_STD_HASHMAP
#include <hash_map>
#define STRING_HASH_MAP(arg) std::hash_map<std::string,arg,stringHasher>
#elif defined(HAVE_GNU_CXX_HASHMAP)
#include <ext/hash_map>
#define STRING_HASH_MAP(arg) __gnu_cxx::hash_map<std::string,arg,stringHasher>
#elif defined(HAVE_EXT_STD_HASHMAP)
#include <ext/hash_map>
#define STRING_HASH_MAP(arg) std::hash_map<std::string,arg,stringHasher> 
#else
#error "hash_map not available"
#endif

#include <string>

struct stringHasher
{
  size_t operator () (const std::string& s) const
  {
#if defined(HAVE_STD_HASHMAP) || defined(HAVE_EXT_STD_HASHMAP)
    return std::hash<const char*>()(s.c_str());
#elif defined(HAVE_GNU_CXX_HASHMAP)
    return __gnu_cxx::hash<const char*>()(s.c_str());
#else
#error
#endif
  }
};

#endif // LOCAL_HASH_MAP_H
