//
//  The Worldforge Project
//  Copyright (c) 2002  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the WorldForge Web Site at http://www.worldforge.org.
//
//  Created by Ron Steinke, 5/24/2002
///

#ifndef LOCAL_SLIST_H
#define LOCAL_SLIST_H

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#ifdef HAVE_STD_SLIST
#include <slist>
#define LOCAL_SLIST(arg) std::slist<arg>
#elif defined(HAVE_GNU_CXX_SLIST) 
#include <ext/slist>
#define LOCAL_SLIST(arg) __gnu_cxx::slist<arg>
#elif defined(HAVE_EXT_STD_SLIST)
#include <ext/slist> 
#define LOCAL_SLIST(arg) std::slist<arg>
#else
#error "slist not available"
#endif

#include <string>
typedef LOCAL_SLIST(std::string) StringSList;

#endif // LOCAL_SLIST_H
