//
//  The WorldForge Project
//  Copyright (c) 1999  The WorldForge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the WorldForge Web Site at http://www.worldforge.org.
//
//


#include <iostream>

#if !defined(_MY_TIME_H_)
#define _MY_TIME_H_

/* my_time originally written by Arnan ?
   ported to use SDL_GetTicks which provides 10ms/50ms granularity on 
   _all_ platforms. by Karsten, 25.7.99

   03.05.2000 Karsten
      changed behavior of my_time(), it sets state to "now" by calling
      set_now()
*/

///
class my_time
{
private:
  ///
  long int mseconds;

public:
  ///
  my_time();
  ///
  my_time(int t);
  ///
  ~my_time() {};
  
  ///
  void set_now();
  ///means later
  bool operator>(const my_time &t);
  ///means earlier
  bool operator<(const my_time &t);
  ///
  friend my_time operator+(const my_time &t1, const my_time &t2);
  ///
  friend my_time operator-(const my_time &t1, const my_time &t2);
  ///milliseconds
  long int operator() () const { return mseconds; }; 
  ///
  my_time &operator=(const my_time &t);
  ///
  friend std::ostream &operator<<(std::ostream &out,const my_time &t);
};


#endif
	
