//
//  The Worldforge Project
//  Copyright (C) 1998-2002  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// Created by Malcolm Walker, 03/15/2002

#ifndef _WIDGETS_H
#define _WIDGETS_H

#include <uta/togglebutton.h>
#include <uta/lineedit.h>
#include <uta/listbox.h>

class FixLineEdit : public uta::LineEdit
{
  public:
  ///
  FixLineEdit(uta::Widget* parent, int x, int y);
  ///
  virtual ~FixLineEdit() {};
};

class FixComboEdit : public uta::LineEdit
{
	public:
		FixComboEdit(uta::Widget* parent, int x, int y);
		virtual ~FixComboEdit() {};

		void setList (std::vector<std::string>& newlist);

	protected:
		uta::ListBox* _list;
		uta::ToggleButton* _dropButton;
		bool _listVisible;
		uta::Widget* _parent;

		void dropDown();
		void rollUp();
		void updateText(const char* t);

};

#endif
