//
//  The Worldforge Project
//  Copyright (C) 1998,1999  The Worldforge Project
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
//
//  For information about Worldforge and its authors, please contact
//  the Worldforge Web Site at http://www.worldforge.org.
//
// created by Karsten Laux 01/2000

#ifndef _DISPATHCER_H_
#define _DISPATCHER_H_

#include <string>
#include "toolbox/local_slist.h"

#include "dii/dii.h"

namespace UClient {

///
class Dispatcher : public DII::Module
{

 public:
  ///
  Dispatcher();
  ///
  ~Dispatcher();

  ///
  DII::Object init(const DII::Object&) {return DII::FAILURE;}
  ///
  DII::Object deinit(const DII::Object&) {return DII::FAILURE;}

  ///
  void unloadAll();

  ///
  DII::Object mod_load(const DII::Object&);
  ///
  DII::Object script_load(const DII::Object&);

  ///
  DII::Object mod_unload(const DII::Object&);
  ///
  DII::Object mod_reload(const DII::Object&);
  ///
  DII::Object queryModules(const DII::Object&);
  ///
  DII::Object queryMethods(const DII::Object&);
  ///
  DII::Object help(const DII::Object&);

};

extern Dispatcher dispatcher;

}

#endif
