#include "decoders.h"
#include <uta/debug.h>
#include <iostream>

using std::cerr;
using std::endl;

void SightDecoder::process(const Message::Object& o)
{
  debugN(5, 
  {
    cerr << "SightDecoder::process(...) got ";
    if(!o.IsMap())
      {
	cerr << "invalid object (no MapType!) " << endl;
      return;
      }
    if (o.AsMap().find("parents") == o.AsMap().end())
      { 
	cerr << "unknown object " << endl;
      }
    else
      {
      std::string
        parent((*(*o.AsMap().find("parents")).second.AsList().begin()).AsString());
      cerr << parent << " object" << endl;
      }
  });

  processed_ = false;
  Objects::Decoder::ObjectArrived(o);
}

void SightDecoder::UnknownObjectArrived(const Message::Object& o)
{
  if(!processed_)
    {
      //      cerr << "An sight of an unknown operation arrived." << endl << flush;
      rawObj(o);
    }
}

void SightDecoder::ObjectArrived(const Operation::Create& o)
{
  //  cerr << "An sight of an create operation arrived." << endl << flush;
  createOp(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Operation::Move& o)
{
  //  cerr << "An sight of an move operation arrived." << endl << flush;
  moveOp(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Operation::Set& o)
{
  //  cerr << "An sight of an set operation arrived." << endl << flush;
  setOp(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Operation::Delete& o)
{
  //  cerr << "An sight of an delete operation arrived." << endl << flush;
  deleteOp(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Operation::Action& o)
{
  //  cerr << "An sight of an action operation arrived." << endl << flush;
  actionOp(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Entity::Account& o)
{
  //  cerr << "An sight of an account arrived." << endl << flush;
  account(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Entity::Admin& o)
{
  //  cerr << "An sight of an account arrived." << endl << flush;
  // Accounts may come through as parents = admin
  account(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Entity::Player& o)
{
  //  cerr << "An sight of an account arrived." << endl << flush;
  // Accounts may come through as parents = player
  account(o);
  processed_ = true;
}

void SightDecoder::ObjectArrived(const Entity::GameEntity& ge)
{
	gameEntity(ge);
	processed_ = true;
}

void SoundDecoder::process(const Message::Object& o)
{
  debugN(5, 
  {
    cerr << "SoundDecoder::process(...) got ";
    if(!o.IsMap())
      {
	cerr << "invalid object (no MapType!) " << endl;
	return;
      }
    if (o.AsMap().find("parents") == o.AsMap().end())
      { 
	cerr << "unknown object " << endl;
      }
    else
      {
	std::string
	  parent((*(*o.AsMap().find("parents")).second.AsList().begin()).AsString());
	cerr << parent << " object" << endl;
      }
  });

  processed_ = false;
  Objects::Decoder::ObjectArrived(o);
}

void SoundDecoder::UnknownObjectArrived(const Message::Object& o)
{
  if(!processed_)
    {
      // cerr << "An sound of an unknown operation arrived." << endl << flush;
      rawObj(o);
    }
}

void SoundDecoder::ObjectArrived(const Operation::Create& o)
{
  //  cerr << "An sound of an create operation arrived." << endl << flush;
  createOp(o);
  processed_ = true;
}

void SoundDecoder::ObjectArrived(const Operation::Move& o)
{
  //  cerr << "An sound of an move operation arrived." << endl << flush;
  moveOp(o);
  processed_ = true;
}

void SoundDecoder::ObjectArrived(const Operation::Set& o)
{
  //  cerr << "An sound of an set operation arrived." << endl << flush;
  setOp(o);
  processed_ = true;
}

void SoundDecoder::ObjectArrived(const Operation::Talk& o)
{
  //  cerr << "An sound of an talk operation arrived." << endl << flush;
  talkOp(o);
  processed_ = true;
}

void SoundDecoder::ObjectArrived(const Operation::Action& o)
{
  //  cerr << "An sound of an action operation arrived." << endl << flush;
  actionOp(o);
  processed_ = true;
}
