#ifndef _WORLD_DECODERS_H_
#define _WORLD_DECODERS_H_

#include <Atlas/Objects/Decoder.h>
#include <Atlas/Objects/Entity/GameEntity.h>    
#include <sigc++/signal_system.h>

using namespace Atlas::Objects;
using namespace Atlas;

class SightDecoder : public Objects::Decoder, virtual public SigC::Object
{
protected:
   void UnknownObjectArrived(const Atlas::Message::Object&);
   void ObjectArrived(const Objects::Operation::Create&);
   void ObjectArrived(const Objects::Operation::Move&);
   void ObjectArrived(const Objects::Operation::Set&);
   void ObjectArrived(const Objects::Operation::Delete&);
   void ObjectArrived(const Objects::Operation::Action&);
   void ObjectArrived(const Objects::Entity::Account&);
   void ObjectArrived(const Objects::Entity::Admin&);
   void ObjectArrived(const Objects::Entity::Player&);
	 void ObjectArrived(const Objects::Entity::GameEntity&);
   bool processed_;

public:
   void process(const Atlas::Message::Object&);

   SigC::Signal1<void, const Atlas::Message::Object&> rawObj;
   SigC::Signal1<void, const Objects::Operation::Create&> createOp;
   SigC::Signal1<void, const Objects::Operation::Move&> moveOp;
   SigC::Signal1<void, const Objects::Operation::Set&> setOp;
   SigC::Signal1<void, const Objects::Operation::Delete&> deleteOp;
   SigC::Signal1<void, const Objects::Operation::Action&> actionOp;
   SigC::Signal1<void, const Objects::Entity::Account&> account;        
	 SigC::Signal1<void, const Objects::Entity::GameEntity&> gameEntity;
};

class SoundDecoder : public Objects::Decoder, virtual public SigC::Object
{
protected:
   void UnknownObjectArrived(const Atlas::Message::Object&);
   void ObjectArrived(const Objects::Operation::Create&);
   void ObjectArrived(const Objects::Operation::Move&);
   void ObjectArrived(const Objects::Operation::Set&);
   void ObjectArrived(const Objects::Operation::Talk&);
   void ObjectArrived(const Objects::Operation::Action&);

   bool processed_;

public:
   void process(const Atlas::Message::Object&);  

   SigC::Signal1<void, const Atlas::Message::Object&> rawObj;   
   SigC::Signal1<void, const Objects::Operation::Create&> createOp;
   SigC::Signal1<void, const Objects::Operation::Move&> moveOp;
   SigC::Signal1<void, const Objects::Operation::Set&> setOp;
   SigC::Signal1<void, const Objects::Operation::Talk&> talkOp;
   SigC::Signal1<void, const Objects::Operation::Action&> actionOp;

};

#endif
