#include "world_adaptor_renderer.h"
#include "operation.h"
#include "../renderer/renderer.h"

using namespace World;

void 
RendererAdaptor::disappeared(const Entity* ent)
{
    if(ent->id() == "world_0")
	return;
  //  if disappeared remove it from display list: 
  deleted(ent);
}

void 
RendererAdaptor::moved(const Entity* entity)
{
   if(!entity->visible())
    return; 
    if(entity->id() == "world_0")
	return;
   try
     {
       Renderer::instance()->move(entity);
     }  
   catch(...)
     {
       cerr << "Renderer failed to move entity ! " << endl;
     }
 
   
}

void 
RendererAdaptor::changed(const Entity* entity)
{
    if(entity->id() == "world_0")
	return;

  if(!entity->visible())
    {
      //if this entity is not visible (anymore), remove it 
      try
	{
	  Renderer::instance()->remove(entity->id());
	}
      catch(...)
	{
	  cerr << "Renderer failed to remove entity ! " << endl;
	}

      return;
    }


  try
    {
      Renderer::instance()->update(entity);
    }
  catch(...)
    {
      cerr << "Renderer failed to update entity ! " << endl;
    }

}

void 
RendererAdaptor::deleted(const Entity* entity)
{
    if(entity->id() == "world_0" || !Renderer::instance())
	return;
  try
    {
      Renderer::instance()->remove(entity->id());
    }  
  catch(...)
    {
      cerr << "Renderer failed to remove entity ! " << endl;
    }

}

void 
RendererAdaptor::created(const Entity* entity)
{
    if(entity->id() == "world_0")
	return;

    //Renderer does "auto-creation"
    changed(entity);
}
